-- Created by Alexander Okhota (Hunt) hunt_hunt@rambler.ru --

global HuntUtilitiesDir = undefined
while HuntUtilitiesDir == undefined or HuntUtilitiesDir == "" do
(	HuntUtilitiesDir = ""
	local f = GetOpenFileName caption:"Please select HuntModifiers.hu file" types:"HuntModifiers.hu|HuntModifiers.hu"
	if f != undefined then 
	(	HuntUtilitiesDir = getFileNamePath f
	)
)

sDir = scriptsPath + "startup\\HuntModifiers.ms"
deleteFile sDir

bOk2 = copyFile (HuntUtilitiesDir + "HuntModifiers.hu") sDir
if bOk2 == true then fileIn sDir

------------------------------------------------------------------------------------
------------------------ Help ------------------------------------------------------
------------------------------------------------------------------------------------

macroScript HuntUtilities
category:"HuntUtilitiesTools"
tooltip:"Hunt Utilities"
ButtonText:"HuntUtilities Help"
(
	global sVersion = "HuntUtilities v 4.03"

	global floater_add
	
	global asdViewPortChange
	global asdRemoveScripts
	global asdAddScripts
	global asdTimeChange
	
	global HuntUtilitiesDir
	
	global fnSetProp
	global fnGetProp
	
	if floater_add != undefined do
	(	closerolloutfloater floater_add
	)

	
rollout helpRollout "HuntUtilities Help" width:323 height:166
(
	button btn1 "Help" pos:[199,9] width:114 height:24
	checkbox chkDisable "Disable HuntModifiers" pos:[13,12] width:159 height:14 checked:false
	label lbl11 "Author of HuntUtilities - Alexander Okhota (Hunt)" pos:[17,60] width:287 height:16
	label lbl12 "hunt@speechanimator.com" pos:[17,80] width:155 height:16
	label lbl13 "www.speechanimator.com/HuntUtilities/" pos:[17,94] width:268 height:16
	GroupBox grp25 "HuntUtilities" pos:[7,38] width:309 height:79
	label lbl15 "Use automatic facial animation technology SpeechAnimator" pos:[10,126] width:287 height:15
	label lbl16 "www.speechanimator.com" pos:[10,141] width:220 height:16
	on helpRollout open do
	(	
		global bServerMode
		global asdCanGCOnViewPortChange
		global asdHuntModifiersDisabled
		global asdHuntShowBorders
		global asdHuntShowPropText 
		global asdExcludeObjectUnhide
		global sVersion
		
		grp25.caption = sVersion
		if asdHuntModifiersDisabled != undefined then 
			chkDisable.checked = asdHuntModifiersDisabled
	
	)
	on btn1 pressed do
	(
		sDir = scriptsPath 
		sDir += "\\HuntUtilities.txt"
		
		ShellLaunch sDir ""
	)
	on chkDisable changed state do
	(		global asdAddScripts
			global asdRestoreCameraLights
			global asdViewPortChange
			global asdHuntModifiersDisabled = false
		
			
			if chkDisable.checked == true and asdRemoveScripts != undefined then 
			(	asdRestoreCameraLights()
				asdRemoveScripts()
				completeRedraw()
			)
	
	
		
		if chkDisable.checked == false and asdAddScripts != undefined then 
		(	asdViewPortChange true undefined false
			asdAddScripts()
			completeRedraw()
		)
		
		asdHuntModifiersDisabled = chkDisable.checked
	)
)



createDialog helpRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)


------------------------ Jenia ------------------------------------------------------
------------------------------------------------------------------------------------
macroScript HuntUtilitiesAutoKey
category:"HuntUtilitiesTools" 
toolTip:"HU AutoKey" 
buttontext:"HU AutoKey"
( 


rollout jeniaRollout "HU AutoKey" width:338 height:85
(
	GroupBox grp1 "AutoKey" pos:[8,8] width:319 height:70
	label lbl1 "time range:" pos:[24,24] width:56 height:16
	edittext edt1 "" pos:[104,24] width:40 height:16
	label lbl2 "from" pos:[80,24] width:24 height:16
	label lbl3 "to" pos:[152,24] width:16 height:16
	edittext edt3 "" pos:[176,24] width:40 height:16
	button btn3 "active time segment" pos:[98,49] width:116 height:16
	--pickButton btn4 "pick animated object" pos:[24,48] width:160 height:24
	button btn6 "set keys..." pos:[228,27] width:86 height:37

	on jeniaRollout open do
	(	
		edt1.text = animationRange.start.frame as string
		edt3.text = animationRange.end.frame as string
	)
	on btn3 pressed do
	(
		edt1.text = animationRange.start.frame as string
		edt3.text = animationRange.end.frame as string
	)
	on btn6 pressed do
	(
		local animobjs = #()
		local targobjs = #()
		
		local startfr = edt1.text as integer
		local endfr = edt3.text as integer
		
		sliderTime = startfr
		
		--if IsGroupHead(animobj) then
		--(
		--	animobjs=animobj+animobj.children
		--)
		animobjs = selection as Array
		
		if animobjs != undefined and animobjs != #() then
		(
		
		
		--if (classof(animobj)==ObjectSet) then 
		(	--print "group copy"
			maxops.CloneNodes animobjs newNodes:&targobjs --expandHierarchy:true
			--targobj=targobj as array
			for i = 1 to targobjs.Count do
			(	local object = targobjs[i]
				if (classof(object)==Dummy and isgrouphead(object) and (isOpenGrouphead(object) == false)) then 
				(	
					delete targobjs[i]
					targobjs = #(snapshot animobjs[i])
					animobjs = #(animobjs[i])
					exit()
				)
			)
		)
		/*
		else
		(	animobjs = #(animobjs)
			targobjs = copy animobjs #nomap
			--print "single object copy"
		)
		*/
		
		if (animobjs != undefined and animobjs.Count != 0) then 
		(	for i = 1 to animobjs.Count do
			(	animobj = animobjs[i]
				targobj = targobjs[i]
				if animobj == undefined then continue
				
				local oldParent = targobj.parent
				--targobj.parent = animobj
				targobj.parent = undefined
				targobj.Transform.controller = prs()
				deleteKeys targobj.Transform.controller
				--print ("New Obj: " + Classof(targobj)+ targobj.name)
				--targobj.transform=matrix3 0
				for i=startfr to endfr do
				(	--slidertime=i
					animate on
					(	at time i  
						(	targobj.transform = animobj.transform
						--(	targobj.transform = animobj.transform
							-- print (i as string + "---"+targobj.transform as string + "---"+ animobj.transform as string)
						)
					)
				
					--print (targobj.transform)
					--print (animobj.transform)
					--temptrans=copy animobj.transform at time i
					--rgobj.transform= (copy animobj.transform at time i)
			
				)
			
				--targobj.parent = undefined
			)
		)
		
		)
	)
)

createDialog jeniaRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)


----------------------------------Inverse as box ----------------------------------
macroScript HuntUtilitiesInverseViewAsBox
            category:"HuntUtilitiesTools" 
			ButtonText:"HU Inverse View As Box"
            tooltip:"HU Inverse View as Box" 
            Icon:#("ViewportNavigationControls",29)
(
	for object in selection do
	(	if (isProperty object "boxMode") then
		(	object.boxMode = not object.boxMode
		)
	)
)


------------------------------------------------------------------------------------
------------------------ Animation --------------------------------------------
------------------------------------------------------------------------------------

macroScript HuntUtilitiesKeysProps
category:"HuntUtilitiesTools" 
toolTip:"HU Keys' Properties" 
buttontext:"HU Keys' Properties"
( 


rollout animRollout "HU Keys' Properties" width:255 height:134
(
	dropdownList ddlMode "" pos:[19,9] width:125 height:21 items:#("Continuity", "Tension", "Bias")
	spinner spnValue "" pos:[154,11] width:82 height:16 range:[0,50,0] type:#float scale:0.1
	button btnSK "Set value for all selected keys" pos:[15,65] width:222 height:23
	button btnCT "Set value for selected object at current time" pos:[15,37] width:222 height:23
	button btnSKIK "Set free keys for selected keys" pos:[15,93] width:221 height:24
	
fn asdSubAnimEnumerate objectMain fnForKey =
(	
	if (isProperty objectMain "isAnimated") and objectMain.isAnimated != true then return()
	-- print objectMain
	local asdCont = objectMain.controller
	if asdCont != undefined and asdCont.keyable then
	(	--print (superclassof asdCont)
		if asdCont.keys == undefined then return()
		local bBiped = false
		if (superclassof asdCont) as string == "Matrix3Controller" 
			then bBiped = true
		
		for i = 1 to asdCont.keys.count do
		(	local key = undefined 
			if bBiped then key = biped.getKey asdCont i
			else key = getKey asdCont i
			
			fnForKey key
		)
		
		--print (getKey asdCont 1)
		--print (biped.getKey asdCont 1)
					
		return()
	)
	
	local iMax = objectMain.numSubs
	for i = 1 to iMax do
	(	local object = objectMain[i]
		asdSubAnimEnumerate object fnForKey
	)
)

fn fnForSelectedKey key=
(	if key.selected then 
	(	if (isProperty key (ddlMode.selected)) then
		(	case ddlMode.selected of
			(	"Continuity": key.continuity = spnValue.value
				"Tension": key.Tension = spnValue.value
				"Bias": key.Bias = spnValue.value
			)
		)
	)
)

fn fnForCuttentTimeKey key=
(	if key.time == sliderTime then 
	(	if (isProperty key (ddlMode.selected)) then
		(	case ddlMode.selected of
			(	"Continuity": key.continuity = spnValue.value
				"Tension": key.Tension = spnValue.value
				"Bias": key.Bias = spnValue.value
			)
		)
	)
)

fn fnForSelectedIKKey key=
(	if key.selected then 
	(	if (isProperty key "ikSpace") then
		(	key.ikSpace = 0
		)
	)
)

	on btnSK pressed do
	(	undo "Set value for keys" on
		(	local arrSel = selection as array
			for object in arrSel do
			(	asdSubAnimEnumerate object fnForSelectedKey
			)
		)
	)
	on btnCT pressed do
	(	undo "Set value for keys" on
		(	local arrSel = selection as array
			for object in arrSel do
			(	asdSubAnimEnumerate object fnForCuttentTimeKey
			)
		)
	)
	on btnSKIK pressed  do
	(	undo "Set value for keys" on
			(	local arrSel = selection as array
				for object in arrSel do
				(	asdSubAnimEnumerate object fnForSelectedIKKey
				)
			)
		)
)

createDialog animRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)


--------------------------------------------------------------------------
-------------------------------- modeling --------------------------------
--------------------------------------------------------------------------
macroScript HuntUtilitiesModeling
category:"HuntUtilitiesTools"
toolTip:"HU Modeling"
buttontext:"HU Modeling"
(

rollout modelingRollout "HU Modeling" width:209 height:197
(
	button btnSmooth "Set" pos:[137,47] width:61 height:30
	spinner spnIter "Iterations" pos:[25,22] width:93 height:16 enabled:true range:[0,10,1] scale:1
	spinner spnRendIner "" pos:[69,58] width:56 height:16 range:[0,10,1] scale:1
	checkbox chkRender "Render Values:" pos:[11,39] width:102 height:16
	label lbl3 "Iterations" pos:[11,59] width:48 height:12
	GroupBox grp1 "MeshSmooths" pos:[4,86] width:200 height:47
	button btnOn "ON" pos:[14,104] width:59 height:21
	button btnOff "OFF" pos:[129,105] width:59 height:21
	GroupBox grp19 "Copy / Paste between different MAX" pos:[5,135] width:199 height:54
	button btnCopy "Copy" pos:[12,152] width:81 height:26
	button btnPaste "Paste" pos:[113,154] width:81 height:26
	checkbox chkOne "One Level" pos:[127,21] width:68 height:17
	GroupBox grp4 "MeshSmooths and Poly" pos:[4,4] width:201 height:82
	on btnSmooth pressed do
	(	undo "Collapse iterations" on
		(
			disableSceneRedraw()
			statuspanel.visible = true
			--progressStart "Rinning..."
			local arr = selection as array
				
			local maxi = arr.count as float
			local count = 0
			
			for object in arr do
			(	local bRunned = false
			
				if superClassOf object == GeometryClass then
				(
					for modi in object.modifiers do
					(	if classOf modi == meshsmooth then
						(	modi.useRenderIterations = chkRender.Checked
							modi.renderIterations = spnRendIner.value
							modi.iterations = spnIter.value
							if chkOne.checked then 
							(	bRunned = true
								exit()
							)
						)
					)
				)
				
				if chkOne.checked and bRunned then continue
				
				if classOf object.baseobject == Editable_Poly then
				(	object.useRenderIterations = chkRender.Checked
					object.renderIterations = spnRendIner.value
					object.iterations = spnIter.value
				)
					
				count = count + 1
				local iProgress = 100 * (count as float)/ maxi
				--progressUpdate iProgress
				--if getProgressCancel() then exit()
			)
				
			--progressend()
			enableSceneRedraw()
			completeRedraw()
		)
	)
	on btnOn pressed do
	(
		--undo "MeshSmooth ON" on
		(
			disableSceneRedraw()
			statuspanel.visible = true
			local arr = selection as array
				
			for object in arr do
			(	if superClassOf object == GeometryClass then
				(
					for modi in object.modifiers do
					(	if classOf modi == meshsmooth then
						(	modi.Enabled = true
						)
					)
				)
			)
			
			enableSceneRedraw()
			completeRedraw()
		)
	)
	on btnOff pressed do
	(
		--undo "MeshSmooth OFF" on
		(
			disableSceneRedraw()
			statuspanel.visible = true
			local arr = selection as array
				
			for object in arr do
			(	if superClassOf object == GeometryClass then
				(
					for modi in object.modifiers do
					(	if classOf modi == meshsmooth then
						(	modi.Enabled = false
						)
					)
				)
			)
			
			enableSceneRedraw()
			completeRedraw()
		)
	)
	on btnCopy pressed do
	(	if selection.count > 0 then
			saveNodes selection "c:\\temp.max"
		else deleteFile "c:\\temp.max"
	)
	on btnPaste pressed do
		(	mergeMaxFile "c:\\temp.max" #select #mergeDups
	)
)




createDialog modelingRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)



-------------------------------------

------------------------------------------------------------------------------------
--------------------------LIGHTS----------------------------------------------------
------------------------------------------------------------------------------------

macroScript HuntUtilitiesLights
category:"HuntUtilitiesTools"
toolTip:"HU Lights"
buttontext:"HU Lights"
(

rollout lightRollout "HU Lights" width:325 height:202
(
	GroupBox grp1 "IncludeList" pos:[7,0] width:311 height:195
	button btnAdd ">> Append objects >>" pos:[166,164] width:144 height:25
	listbox lbxObject "  Objects" pos:[17,13] width:144 height:7
	listbox lbxLight "   Lights" pos:[168,13] width:144 height:7
	button btnObjects "edit..." pos:[96,13] width:32 height:18
	button btnLights "edit..." pos:[243,12] width:34 height:18
	button btnSelectObjects "Select lights by objects" pos:[15,136] width:145 height:22
	button btnRemove "<< Remove objects <<" pos:[14,165] width:145 height:24
	button btnObje "Select objects by lights" pos:[168,135] width:137 height:23
	button btnObjAdd "add..." pos:[130,13] width:30 height:18
	button btnLTAdd "add..." pos:[280,12] width:31 height:18
	button btnClrObj "clr" pos:[72,13] width:21 height:18
	button btnClrLt "clr" pos:[218,12] width:21 height:18

	fn light_filt obj =
	( 	local bRet = false
		if superClassOf obj == light then bRet = true
		/*
		if isKindOf obj targetSpot then bRet = true
		if isKindOf obj TargetDirectionallight then bRet = true
		if isKindOf obj Omnilight then bRet = true
		if isKindOf obj Directionallight then bRet = true
		if isKindOf obj freeSpot then bRet = true
		*/
		return bRet
	)
	fn obj_filt obj =
	(	local bRet = true
		if isKindOf obj Targetobject then bRet = false
		else bRet = not light_filt(obj)
		return bRet
	)

	on btnAdd pressed do
	(
		for light in lbxLight.items do
		(	local lt = execute ("$'" + light + "'")
			if lt == undefined then
			(	messageBox ("Object " + light +" is undefined!. Ignored.")
				continue
			)
			local a = lt.includeList
			if a == undefined then a = #()
			for object in lbxObject.items do
			(	local o = execute ("$'" + object + "'")
				append a o
			)
			lt.includeList = a
		)
	)
	on btnObjects pressed do
	(
		local selOld = selection as array
		local ar = #()
		
		for objName in lbxObject.items do 
		(	local o = execute ("$'" + objName + "'")
			if o != undefined then (append ar o)
		)
		
		select ar
		
		local a = selectByName title:"Selected Objects" filter:obj_filt showHidden:true
		if a != undefined then
		(	local aTmp = #()
			for obj in a do
				append aTmp obj.name
			lbxObject.items = aTmp
		)
	
		select selOld
	)
	on btnLights pressed do
	(
		local selOld = selection as array
		
		local ar = #()
		
		for objName in lbxLight.items do 
		(	local o = execute ("$'" + objName + "'")
			if o != undefined then (append ar o)
		)
		
		select ar
	
		local a = selectByName title:"Selected Lights" filter:light_filt showHidden:true
		if a != undefined then
		(	local aTmp = #()
			for obj in a do
				append aTmp obj.name
			lbxLight.items = aTmp
		)
		
		select selOld
	)
	on btnSelectObjects pressed do
	(	
		local sel = #()
		statuspanel.visible = true
		progressStart "Running..."
		local maxi = lbxObject.items.count as float
		local count = 0
		for object in lbxObject.items do
		(	count = count + 1
			local iProgress = 100 * (count as float)/ maxi
			progressUpdate iProgress
			if getProgressCancel() then exit()
			
			local obItem = execute ("$'" + object + "'")
			
			for lt in lights do
			(	if not (superClassOf lt) == light then continue
				local a = lt.includeList
				if a != undefined then
				(	for obLt in a do
					(	if obLt == obItem then 
						(	append sel lt
							exit()
						)
					)
				)
			)
		)
		
		progressend()
	
		select sel
	)
	on btnRemove pressed do
	(
		undo "Remove objects" on
		(
			for light in lbxLight.items do
			(	local lt = execute ("$'" + light + "'")
				if lt == undefined then
				(	messageBox ("Object " + light +" is undefined!. Ignored.")
					continue
				)
				local a = lt.includeList
				if a == undefined then continue
	
				local arrIndexDel = #()
				
				for object in lbxObject.items do
				(	local o = execute ("$'" + object + "'")
					local index = findItem a o
					if index > 0 then
					(	append arrIndexDel index
					)
				)
			
				-- print arrIndexDel
				if arrIndexDel.count > 0 then
				(	sort arrIndexDel
					for i = arrIndexDel.count to 1 by -1 do
					(	deleteItem a arrIndexDel[i]
					)
				)
			
				lt.includeList = a
			)
			
		)
	)
	on btnObje pressed do
	(
		local sel = #()
		local selNames = #()
		
		for lt in lbxLight.items do
		(	local ltItem = execute ("$'" + lt + "'")
			if not ltItem == undefined then
			(	local a = ltItem.includeList
				if a != undefined then
				(	for obLt in a do
					(	if (findItem sel obLt) == 0 then 
						(	append sel obLt
							append selNames obLt.name
						)
					)
				)
			)
		)
	
		clearSelection()
		for obj in sel do
		(	local bObjectInCloseGroup = /*(not (isGroupHead obj)) and !!!!!!!!*/(isGroupMember obj) and (not (isOpenGroupMember obj))
			if bObjectInCloseGroup then setGroupMember obj false
			selectMore obj
			if bObjectInCloseGroup then setGroupMember obj true
		)
	)
	on btnObjAdd pressed do
	(
		local a = selectByName title:"Selected Objects" filter:obj_filt showHidden:true
		if a != undefined then
		(	local aTmp = lbxObject.items
			for obj in a do
			(	if (findItem aTmp obj.name) == 0 then
					append aTmp obj.name
			)
			lbxObject.items = aTmp
		)
	)
	on btnLTAdd pressed do
	(
		local a = selectByName title:"Selected Lights" filter:light_filt showHidden:true
		if a != undefined then
		(	local aTmp = lbxLight.items
			for obj in a do
			(	if (findItem aTmp obj.name) == 0 then
					append aTmp obj.name
			)
			lbxLight.items = aTmp
		)
	)
	on btnClrObj pressed do
		(	lbxObject.items = #()
	)
	on btnClrLt pressed do
		(	lbxLight.items = #()
	)
)
createDialog lightRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)


-------------------- Materials -----------------------------
------------------------------------------------------------
macroScript HuntUtilitiesMaterials
category:"HuntUtilitiesTools"
toolTip:"HU Materials"
buttontext:"HU Materials"
(

arrSelObject = #()

rollout materialsRollout "HU Materials" width:332 height:453
(
	button btn1 "Display materials" pos:[218,158] width:105 height:20
	edittext edtPath "Path to copy" pos:[11,22] width:286 height:17
	button btn3 "..." pos:[298,21] width:18 height:17
	edittext edtPrefix "Use file prefix" pos:[12,43] width:128 height:19
	GroupBox grp1 "Relink of maps" pos:[5,5] width:319 height:64
	edittext edtFrom "From" pos:[62,92] width:81 height:19
	edittext edtTo "To" pos:[163,91] width:74 height:19
	GroupBox grp2 "Naming of materials" pos:[5,77] width:317 height:74
	edittext edtPlus "Prefix" pos:[114,120] width:123 height:19
	button btnRename "Rename" pos:[245,91] width:69 height:20
	button btnPrefix2 "Set prefix" pos:[245,119] width:69 height:20
	button btn6 "Go" pos:[277,43] width:40 height:22
	listbox lbxSelected "" pos:[6,182] width:318 height:7
	checkbox chkSelObjects "Only for selected objects" pos:[9,158] width:144 height:18
	button btnSI "Off Self-Illum" pos:[6,392] width:68 height:20
	button btnAmb "Ambient Off" pos:[156,391] width:81 height:20
	button btnSIOn "On Self-Illum" pos:[81,392] width:68 height:20
	colorPicker cp2 "" pos:[185,418] width:37 height:20 title:"Choose a color"
	button btnSaveBitmapAs "Save bitmap as..." pos:[232,416] width:92 height:21
	checkbox chk2 "Checkbox" pos:[29,340] width:0 height:0
	button btnLocal "Local maps" pos:[218,304] width:65 height:23
	GroupBox grp11 "Find and display in material editor" pos:[6,288] width:317 height:45
	button btnOffView "Off view" pos:[9,419] width:52 height:19
	button btnOnView "On view" pos:[69,419] width:52 height:19
	button btnEffect "Effect Chnl = 0" pos:[244,391] width:81 height:20 enabled:false
	checkbox chkCopy "Copy" pos:[164,46] width:44 height:17 checked:true
	checkbox chkRelink "Relink" pos:[217,47] width:53 height:15 checked:true
	button btnSetMap "Set" pos:[257,356] width:51 height:21
	dropdownList ddlMaps "" pos:[64,356] width:110 height:21 items:#("Ambient", "Diffuse", "Specular", "SpecularLevel", "Glossiness", "SelfIllum", "Opasity", "Filter", "Bump", "Reflection", "Refraction", "Displacement") selection:6
	GroupBox grp23 "Set selected material from material editor on selected objects" pos:[3,341] width:317 height:43
	label lbl1555 "Channel" pos:[13,360] width:42 height:16
	checkbox chkMatInstance "Instance" pos:[188,358] width:62 height:18 checked:true
	button btnDirLocal "Dir..." pos:[287,303] width:29 height:24
	button btnFindMat "Find" pos:[125,304] width:49 height:23 enabled:true
	dropdownList ddlTypeMat "" pos:[16,304] width:92 height:21 items:#("Raytrace", "Reflect/Refract", "FlatMirror", "Bump")
	button btnShow "Show" pos:[153,158] width:52 height:20
	
	fn appendMatToList matObject str =
	(	list = lbxSelected.items
		append list str
		append arrSelObject matObject
		lbxSelected.items = list
	)
	
	fn getMapObjectFromMaterial matObject arrFiles edtStream sPlus =
	(
		if matObject == undefined then return()
		else
		if classof matObject == Bitmaptexture then 
		(	if findItem arrFiles matObject == 0 then append arrFiles matObject
			--	else if edtStream != undefined then edtStream.text += "(Duplicate) "
		
			if edtStream != undefined then
			(	local a = getFiles(matObject.FileName)
				local st = sPlus
				if a.count == 0 then st += "NOT FOUND "
				--strText += st
				appendMatToList matObject (st + matObject.name + ": (Texture) - " + matObject.FileName)
			)
		)
		else
		(	local arrNames = getPropNames matObject
			local arrUnicalProp = #()

			if edtStream != undefined then appendMatToList matObject (sPlus + matObject.name + ": (" + ((classof matObject) as string) + ")")
			-- + " - " + (ExprForMaxObject matObject)
						
			for nm in arrNames do
			(	local pr = getProperty matObject nm
				--print pr
			
				if (classof pr) == ArrayParameter then
				(	for obj in pr do
					if (superclassof obj) == material or (superclassof obj) == textureMap then
					(	if (findItem arrUnicalProp obj) == 0 then 
						(	--format "--------1\n"
							--print (ExprForMaxObject obj)
							Append arrUnicalProp obj
						)
					)
				)
				else
				if (superclassof pr) == material or (superclassof pr) == textureMap then
				(	if (findItem arrUnicalProp pr) == 0 then 
					( 	--format "--------2\n"
						--print (ExprForMaxObject pr)
						Append arrUnicalProp pr
					)
				)
			)
			--format "--------3\n"
			--print arrUnicalProp 
			for obj in arrUnicalProp do getMapObjectFromMaterial obj arrFiles edtStream (sPlus + "  ")
		)
	)
	
	fn getAllMaterials edtStream arrFiles =
	(
		progressstart "Running..."
		local sm = sceneMaterials
		if chkSelObjects.checked then
		(	sm = #()
			for object in selection do
				if object.material != undefined then 
					if findItem sm object.material == 0 then
						append sm object.material
		)
		
		local imax = sm.count
		icur = 0
		for object in sm do
		(	progressupdate (((icur as float) / imax) * 100.0)
			if getProgressCancel() then exit()
			
			--if classof object != Bitmaptexture then
				getMapObjectFromMaterial object arrFiles edtStream ""

			icur = icur + 1
		)
		
		if chkSelObjects.checked == false then
		(
			getMapObjectFromMaterial envirinmentMap arrFiles edtStream ""
			for object in lights do
			(	if superClassof object == light then
				(	if (isProperty object #projectorMap) then
						getMapObjectFromMaterial (object.projectorMap) arrFiles edtStream ""
				)
			)
		)
		
		--local asdfg = gc()
		lbxSelected.selection = 1
		
		progressend()
	)
	
	fn getMaterialsOnly arrFilesOut=
	(	
		if arrSelObject.count == 0 then btn1.pressed() 
		
		for object in arrSelObject do
		(	if object == undefined then continue
			/*if (classof object) == Standardmaterial or (classof object) == Multimaterial\
			 or (classof object) == Blend or (classof object) == compositematerial\
			 or (classof object) == RaytraceMaterial then
			-- Get materials: Standard, Blend, Multi, Raytrace, Composite
			 */
			if (superclassof object) == material then
			(	if ((findItem arrFilesOut object) == 0) then append arrFilesOut object
			)
		)
	)
		
	fn copyRelink bCopy bRelink =
	(		-- arrFiles = #()
		arrFiles = materialLibrary()
		-- edtStream.text = ""
		if(lbxSelected.selection > 1) then
		(	object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getAllMaterials undefined arrFiles
	
		undo "Relink map files" on
		(
			forceDirectories edtPath.text
			progressstart "Running..."
			for i = 1 to arrFiles.count do
			(
				object = arrFiles[i]
				if object.classid[1] != 576 then exit()
			
				progressupdate(i * 100.0 / arrFiles.count)
				sNewName = edtPath.text + edtPrefix.text + fileNameFromPath(object.FileName)
				-- print (fileNameFromPath(object.FileName) + " -> " + sNewName)
				-- if getFiles(object.FileName).count == 0 then edtStream.text += "Not found file for " + object.FileName
			
				if bCopy then copyFile object.FileName sNewName
				if bRelink then object.FileName = sNewName
			)
			progressend()
		)
	
		btn1.pressed() 
	)
	
	fn fnIsMat matObject ClassMat=
	(	if matObject == undefined then return false
		
		if (classof matObject) == ClassMat then return true
		
		local arrNames = getPropNames matObject

		for nm in arrNames do
		(	local pr = getProperty matObject nm
			--print pr
			
			if (classof pr) == ArrayParameter then
			(	for object in pr do
				if (superclassof object ) == material or (superclassof object ) == textureMap then
				(	if (fnIsMat object ClassMat) == true then return true
				)
			)
			else
			if (superclassof pr) == material or (superclassof pr) == textureMap then
			(	if (fnIsMat pr ClassMat) == true then return true
			)
		)
		
		return false
	)

	fn fnFindMat ClassMat=
	(	local lib = #()
		max mtledit
		-- undo "Find Raytrace" on
		(
			for i = 1 to meditMaterials.count do
			(	-- object = meditMaterials[i]
				-- if fnIsRayTrace(object) then append lib object
				meditMaterials[i] = standard()
			)

			for object in sceneMaterials do
			(	if (fnIsMat object ClassMat) then append lib object
			)
	
			-- meditMaterials = lib
			
			for i = 1 to lib.count do 
			(	if i > meditMaterials.count then
				(	MessageBox "Limit of list of material editor arrived!"
					exit()
				)
				meditMaterials[i] = lib[i]
			)
			
			medit.UpdateMtlEditorBrackets()
			
		)
	)
	
	fn fnSetMatPart asdMatSel matOut =
	(	
		global asdGMatSel = asdMatSel
		global asdGMatOut = matOut
		
		if (isProperty matOut (ddlMaps.selected + "Map")) then
		(	if chkMatInstance.Checked then 
			(	local command = "asdGMatOut." + ddlMaps.selected + "Map = asdGMatSel"
				execute command
			)
			else
			(	local command = "asdGMatOut." + ddlMaps.selected + "Map = copy asdGMatSel"
				execute command
			)
		)
		
		if ddlMaps.selected == "SelfIllum" and (isProperty matOut "useSelfIllumColor") 
			then matOut.useSelfIllumColor = true
			
	)
	
	on materialsRollout open do
	(
		edtPath.text = "D:\\"
		--btn1.pressed()
	)
	on btn1 pressed do
	(
		lbxSelected.items = #("ALL SELECTED")
		arrSelObject = #()
		
		-- arrFiles = #()
		arrFiles = materialLibrary()
		-- appendMessage edtStream "You can show result in MAXScript Listener."
		getAllMaterials 1 arrFiles
		
		for strText in lbxSelected.items do format (strText + "\n")
		
		-- MessageDeleteOdOd edtStream
	)
	on btn3 pressed do
	(
		fpath = getsavepath caption:"Select output path for copy"
		if fpath != undefined then 
		(	if(fpath[fpath.count]) != "\\" then fpath += "\\"
			edtPath.text = fpath
		)
	)
	on btnRename pressed do
	(
		arrFiles = materialLibrary()
		-- edtStream.text = ""
		if(lbxSelected.selection > 1) then
		(	object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getMaterialsOnly arrFiles
		
		for object in arrFiles do
		(
			local sName = object.name
			local s = edtFrom.Text as string
			local pos = findString sName s
			if s == "*_" then 
			(	pos = findString sName "_"
				if pos != undefined then
				(	s = subString sName 1 pos
					pos = 1
				)
			)
			--local bp = matchPattern sName pattern:s
			
			if pos != undefined then
			(	sName = replace sName pos s.count edtTo.Text
				object.name = sName
			)
		)
		
		btn1.pressed()
		
	)
	on btnPrefix2 pressed do
	(
		arrFiles = materialLibrary()
		if(lbxSelected.selection > 1) then
		(	object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getMaterialsOnly arrFiles
	
		-- edtStream.text = ""
		for object in arrFiles do
		(	object.name = edtPlus.Text + object.name
		)
	
		btn1.pressed() 
	)
	on btn6 pressed do
		(	copyRelink chkCopy.checked chkRelink.checked
	)
	on lbxSelected doubleClicked sel do
	(
		btnShow.pressed()
	)
	on chkSelObjects changed state do
		btn1.pressed()
	on btnSI pressed do
	(	
		arrFiles = materialLibrary()
		if(lbxSelected.selection > 1) then
		(	object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getMaterialsOnly arrFiles
		 -- else getAllMaterials undefined arrFiles
		 for object in arrFiles do
			 if object != undefined then 
			 (	if (classof object) == Standardmaterial then
			 	(	object.selfillumMapEnable = off
				 	object.selfIllumAmount = 0
				)
			 )
	)
	on btnAmb pressed do
	(
		arrFiles = materialLibrary()
		if(lbxSelected.selection > 1) then
		(	object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getMaterialsOnly arrFiles
		 -- else getAllMaterials undefined arrFiles
		for object in arrFiles do
			if object != undefined then 
			(	if (classof object) == Standardmaterial then
				(	object.adTextureLock = off
			 		object.adLock = off
				)
			)
	)
	on btnSIOn pressed do
	(	arrFiles = materialLibrary()
		if(lbxSelected.selection > 1) then
		(	object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getMaterialsOnly arrFiles
		 -- else getAllMaterials undefined arrFiles
		 for object in arrFiles do
			 if object != undefined then 
			 (	if (classof object) == Standardmaterial then
			 	(	object.selfillumMapEnable = on
				)
			 )
	)
	on btnSaveBitmapAs pressed do
	(
			local ret = getSaveFileName caption:"Save bitmap as..." filaname:"*.tga" types:"*.tga|*.tga|*.bmp|*.bmp|*.*|*.*"
			if ret != undefined then
			(	local b = bitmap 16 16 color:cp2.color filename:ret
				save b
			)
	)
	on btnLocal pressed do
	(
		local lib = #()
		max mtledit
		-- undo "Find" on
		(
			for i = 1 to meditMaterials.count do
			(	-- object = meditMaterials[i]
				-- if fnIsRayTrace(object) then append lib object
				meditMaterials[i] = standard()
			)
			
			arrFiles = materialLibrary()
			getAllMaterials undefined arrFiles
				
			local iCurrent = 1
			for i = 1 to arrFiles.count do 
			(	if iCurrent > meditMaterials.count then exit()
				local object = arrFiles[i]			
				if object != undefined then 
				(	if object.classid[1] == 576 then
					(	
						local pos = findString object.FileName ":\\"
						print object.FileName
						if pos == 2 then
						(	if (lowercase (subString object.FileName 1 1)) != "z" then
							(	meditMaterials[iCurrent] = object
								iCurrent = iCurrent + 1
							)
						)
	                   	else
	                    (	pos = findString object.FileName "\\"
							if pos == undefined then
							(	meditMaterials[iCurrent] = object
								iCurrent = iCurrent + 1
							)
	                	)
					)
				)
			)
			
			medit.UpdateMtlEditorBrackets()
		)
	)
	on btnOffView pressed do
	(
		local arrFiles = materialLibrary()
		if(lbxSelected.selection > 1) then
		(	local object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getMaterialsOnly arrFiles
		 -- else getAllMaterials undefined arrFiles
		 for object in arrFiles do
			 if object != undefined and (classof object != Multimaterial) then 
			 (	object.showInViewPort = off
			 )
	
	)
	on btnOnView pressed do
	(
		local arrFiles = materialLibrary()
		if(lbxSelected.selection > 1) then
		(	local object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else getMaterialsOnly arrFiles
		 -- else getAllMaterials undefined arrFiles
		 for object in arrFiles do
			 if object != undefined and (classof object != Multimaterial) then 
			 (	object.showInViewPort = on
			 )
	)
	on btnEffect pressed do
	(	
		arrFiles = materialLibrary()
		if(lbxSelected.selection > 1) then
		(	object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then append arrFiles object
		)
		else 
		(	getMaterialsOnly arrFiles
			getAllMaterials undefined arrFiles
		)
		
		for object in arrFiles do
		(	 if object != undefined then 
			 (	--if (classof object) != Multimaterial and (classof object) != Bitmap then
			 	-- setProperty object #effectsChannel 0
				--local a = getPropNames object
				--print a
				
				if isProperty object #effectsChannel then 
				(	
					if object.effectsChannel != 0 then
					(	print object
						print ("has effectsChannel " + (object.effectsChannel as string))
						object.effectsChannel = 0
					)
				)
			 )
		)
	)
	on btnSetMap pressed do
	(
		local asdMatSel = medit.GetCurMtl()
		if (superclassof asdMatSel) == texturemap then 
		(	if(queryBox ("Operation will set material \"" + (asdMatSel as string) + "\"\ninto channel " + \
					ddlMaps.selected + " of selected objects' materials.")) then
			(	undo "Set materials" on 
				(	
					local bPrev = chkSelObjects.checked
					chkSelObjects.checked = true
					--getMaterialsOnly arrFilesOut
					
					arrFiles = materialLibrary()
					getMaterialsOnly arrFiles
					--getAllMaterials undefined arrFiles
					for object in arrFiles do
					(	if object != undefined then 
						(	--print object
							fnSetMatPart asdMatSel object
						)
					)
				
					/*
					for object in selection do
					(	if object != undefined and (isDeleted object) == false and object.material != undefined then
						(	local matOut = object.material
							if isKindOf matOut multimaterial then
							(	for object in matOut.materialList do
									fnSetMatPart asdMatSel object
							)
							else 
								fnSetMatPart asdMatSel matOut
						)
					)
					*/
					
					chkSelObjects.checked = bPrev
				)
			)
		)
		else (MessageBox "Select object in material editor is not texture!")
		
		-- chkMatInstance
		-- ddlMaps.selection
	)
	on btnDirLocal pressed do
	(	local fpath = getsavepath caption:"Select input path"
		if fpath != undefined then
		(	if(fpath[fpath.count]) != "\\" then fpath += "\\"
			if not doesFileExist (fpath + "report.txt") then 
				close (CreateFile (fpath + "report.txt"))
		
			local arrFiles = (getFilesRecursive fpath "*.max")
			
			setSilentMode on
			
			for object in arrFiles do
			(	local txtf = getFileNamePath object
				txtf = txtf + getFileNameFile object
				txtf = txtf + ".txt"
				if not doesFileExist txtf then
				(	local file = CreateFile txtf
					if (loadMaxFile object) then
					(	btnLocal.Pressed()
						local arm = #()
						for mat in meditMaterials do
						(	if mat.classid[1] != 576 then exit()
							append arm mat
						)
						
						if arm.count > 0 then
						(	local f = openFile (fpath + "report.txt") mode:"at"
							format "----------------------------------------------------\n" to:f
							format (object + "\n") to:f
							format "----------------------------------------------------\n" to:f
							for mat in arm do
							(	format ((mat.name as string) + " - " + mat.FileName + "\n") to:f
							)
							close f
						)
					)
					else 
					(
					)
					
					close file
				)
				
				local asdf = gc()
			)
			
			setSilentMode off
		)
	)
	on btnFindMat pressed do
	(
		if ddlTypeMat.selected == "Raytrace" then fnFindMat(Raytrace)
		if ddlTypeMat.selected == "Reflect/Refract" then fnFindMat(Reflect_Refract)
		if ddlTypeMat.selected == "FlatMirror" then fnFindMat(Flat_Mirror)
		if ddlTypeMat.selected == "Bump" then 
		(	
			arrFiles = materialLibrary()
			if(lbxSelected.selection > 1) then
			(	object = arrSelObject[lbxSelected.selection - 1]
				if(object != undefined) then append arrFiles object
			)
			else getMaterialsOnly arrFiles
			 -- else getAllMaterials undefined arrFiles
			 
			 
		local lib = #()
		max mtledit
		-- undo "Find Raytrace" on
	
			for i = 1 to meditMaterials.count do
			(	-- object = meditMaterials[i]
				-- if fnIsRayTrace(object) then append lib object
				meditMaterials[i] = standard()
			)
	
			 
			 for object in arrFiles do
				 if object != undefined then 
				 (	if (classof object) == Standardmaterial then
				 	(	if object.BumpMap != udefined then 
							append lib object
					)
				 )
				 
				 
			for i = 1 to lib.count do 
			(	if i > meditMaterials.count then
				(	MessageBox "Limit of list of material editor arrived!"
					exit()
				)
				meditMaterials[i] = lib[i]
			)
			
			medit.UpdateMtlEditorBrackets()
				 
		)
	)
	on btnShow pressed do
	(
		if(lbxSelected.selection > 1) then
		(	local object = arrSelObject[lbxSelected.selection - 1]
			if(object != undefined) then 
			(	max mtledit
				meditMaterials[meditMaterials.count] = object
			)
		)
	)
)







createDialog materialsRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)




------------------------------------------------------------------------------------
-- Naming -----------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
macroScript HuntUtilitiesNaming
category:"HuntUtilitiesTools"
toolTip:"HU Object Naming"
buttontext:"HU Object Naming"
(

rollout NamingRollout "HU Object Naming" width:329 height:262
(
	edittext editPlus "Append prefix" pos:[17,46] width:174 height:17 enabled:true
	button btn1 "Add prefix for objects" pos:[201,44] width:113 height:25
	GroupBox grp1 "Append prefix or postfix to names" pos:[3,5] width:316 height:107
	label lbl23 "For object' names select objects first, set prefix and press [Change]" pos:[11,218] width:177 height:30
	
	GroupBox grp2 "Change first character on lower" pos:[4,203] width:317 height:50
	label lbl1 "Select objects first and press needed button" pos:[18,22] width:293 height:17
	button btn5 "Change" pos:[202,219] width:113 height:25
	
	GroupBox grp4 "Part of names change" pos:[4,115] width:318 height:82
	edittext edtFrom "From" pos:[10,167] width:92 height:17 
	edittext edtTo "On  " pos:[109,165] width:91 height:17 
	label lbl5 "Select objects first, set [From] and [On] fields and press [Change for objects]." pos:[14,131] width:295 height:25
	button btn6 "Change for objects" pos:[215,163] width:102 height:25 enabled:true
	
	edittext edtPost "Append postfix" pos:[14,78] width:178 height:17 enabled:true
	button btnPost "Add postfix for objects" pos:[202,76] width:113 height:25
	on btn1 pressed do
	(
		for object in selection do
		(
			object.name = editPlus.Text + object.name
		)
	
		if floater_add != undefined then 
			closeRolloutFloater floater_add
	)
	on btn5 pressed do
	(
		-- undo "Change first character in names" on 
		( 	for object in selection do
			(
				object.name = lowercaseOneOnly (object.name)
			)
		)
		
		if floater_add != undefined then 
			closeRolloutFloater floater_add
	
	)
	on btn6 pressed do
	(
		for object in selection do
		(
			local sName = object.name
			local s = edtFrom.Text as string
			pos = findString sName s
			if pos != undefined then
			(	sName = replace sName pos s.count edtTo.Text
				object.name = sName
			)
		)
		
		--if floater_add != undefined then 
		-- closeRolloutFloater floater_add
	)
	on btnPost pressed do
	(
		for object in selection do
		(
			object.name = object.name + edtPost.Text
		)
	
		if floater_add != undefined then 
			closeRolloutFloater floater_add
	)
)
/*
on execute do
(
	createDialog NamingRollout
)
*/



createDialog NamingRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)







macroScript HuntUtilitiesRender
category:"HuntUtilitiesTools"
toolTip:"HU Render Thumbnails"
buttontext:"HU Render Thumbnails"
(



------------------------------------------------------------------------------------
--------------------------RENDER Thumbnails-----------------------------------------
------------------------------------------------------------------------------------
rollout renderRollout "HU Render Thumbnails" width:333 height:277
(
	label lbl65 "Select some objects with morpher modifier (one name object MUST have (f_normal)), set [MAX options] except Render Output part, set type of files, set output directory and press [Render morphemes]." pos:[16,25] width:299 height:55
	GroupBox grp49 "Render all morphemes" pos:[10,5] width:315 height:102
	radiobuttons rdo1 "Type of files" pos:[13,193] width:45 height:46 labels:#("TGA", "JPG") columns:1
	edittext edtPath "Output" pos:[10,250] width:295 height:17
	button btn82 "..." pos:[307,251] width:18 height:17
	button btn97 "MAX render options" pos:[99,200] width:121 height:29
	button btn113 "Render selection sets" pos:[180,149] width:132 height:29
	label lbl80 "You can also render all selection sets wich name has prefix one by one." pos:[18,134] width:158 height:39
	GroupBox grp6 "Render selection sets" pos:[11,115] width:312 height:69
	button btn17 "Render morphemes" pos:[183,72] width:132 height:29
	edittext edtPrefix "Use prefix" pos:[193,125] width:116 height:17
	edittext edtStep "Step" pos:[102,81] width:67 height:17 enabled:true
	checkbox chkDouble "Pair render" pos:[21,80] width:74 height:16 enabled:false checked:false
	fn asdSetMorphems baseObject sel numCh value=
	(
		local objMorth = baseObject.modifiers[#Morpher]
		local channel = objMorth[numCh]
		local countObj = sel.count
		
		channel.value = value
		local nameCh = channel as string
		--		nameCh == "SubAnim:_1__Sphere02___Target_Available"
		local posBeg = findString nameCh "__" + 2
		local posEnd = findString nameCh "___"
		nameCh = substring nameCh posBeg (posEnd - posBeg)
		local sFileName = nameCh
		-- ???? ???? ?????? == ????? ??????? ???????
		local nameChLow = lowercase(nameCh)
		nameChLow = substring nameChLow 2 nameChLow.count
		-- print nameChLow
	
		for i = 1 to countObj do
		(	if sel[i] != baseObject then 
			(	local object = sel[i]
				local objMorthLocal = object.modifiers[#Morpher]
				local nameObjectLocal = lowercase (object.name)
				-- print nameObjectLocal
				
				if(objMorthLocal != undefined) then
				(	
					local iObjectLocal = findString nameObjectLocal "_normal"
					if((iObjectLocal != undefined)) then
					(
						local nameObjectLocal = substring nameObjectLocal 1 (iObjectLocal - 1)
						
						for jLocal=1 to 100 do
						(	channelLocal = objMorthLocal[jLocal]
							if channelLocal.value != undefined then 
							(	nameChLocal = channelLocal as string
								posBeg = findString nameChLocal "__" + 2
								posEnd = findString nameChLocal "___"
								local nameChLocal = substring nameChLocal posBeg (posEnd - posBeg)
								local nameChLowLocal = lowercase(nameChLocal)
								nameChLowLocal = subString nameChLowLocal iObjectLocal nameChLowLocal.count
								-- print (nameChLowLocal + " - found in " + nameChLow)
								
								if(nameChLowLocal == nameChLow) then
								(	channelLocal.value = value
									print ("channel " + nameChLowLocal + " was found in " + nameObjectLocal)
								)
								--else channelLocal.value = 0
							)
						)
					)
				)
			)
		)
	
		return sFileName
	)

	on renderRollout open do
	(
		edtPath.text = "D:\\"
		edtStep.text = "100"
	)
	on btn82 pressed do
	(
		fpath = getsavepath caption:"Select output path for render"
		if fpath != undefined then 
		(	if(fpath[fpath.count]) != "\\" then fpath += "\\"
			edtPath.text = fpath
		)
	)
	on btn97 pressed do
		max render scene
	on btn113 pressed do
	(	iMax = selectionSets.count
		if(iMax == 0) then messagebox "Selection sets missing!"
		else 
		(	forceDirectories edtPath.text
			progressstart "Running..."
			for i = 1 to selectionSets.count do
			(
				progressupdate(i * 100.0 / iMax)
				if getProgressCancel() then exit()
				nameSelection = getNamedSelSetName(i)
				res = 1
				if edtPrefix.text != "" then res = findString nameSelection edtPrefix.text
				if res == 1 then
				(	hide geometry
					s = selectionSets[i]
					unhide s
					max tool zoomextents
					
					sFileName = nameSelection
					sFileName = edtPath.text + sFileName
					if rdo1.state == 1 then sFileName += ".tga"
					else sFileName += ".jpg"
					print sFileName
					
					render outputfile:sFileName vfb:off
					
					unhide geometry
				)
			)	
			progressend()
		)
	)
	on btn17 pressed do
	(
	
	------------------------------------------------------------
	countObj = selection.count
	baseObject = undefined
	iObjectMain = undefined
	
	for i = 1 to countObj do
	(	local object = selection[i]
		sName =  lowercase (object.name)
		pos = findString sName  "f_normal"
		if pos != undefined then
		(	baseObject = object
			iObjectMain = i
		)
	)
	
	
	if countObj == 0 then messagebox "None selected!"
	else if(baseObject == undefined) then messagebox "Objects on mask (*f_normal*) is not found in selected!"
	
	if(baseObject != undefined and countObj > 0) then
	(	
	forceDirectories edtPath.text
	progressstart "Running..."
	
	objMorth = baseObject.modifiers[#Morpher]
	
	if  objMorth == undefined then 
	(	messageBox "Morpher modifier is not found."
		throw ""
	)
	
	channel = objMorth[1]
	NumChannels = 0;
	if channel.value != undefined then NumChannels = 1;
	
	while channel.value != undefined do 
	(	NumChannels = NumChannels + 1
		channel = objMorth[NumChannels]
	)
	
	NumChannels = NumChannels  - 1;
	
	for j=1 to NumChannels do
	(	channel = objMorth[j]
		channel.value = 0
	)
	
	-- for j=1 to 5 do
	local bStop = false
	for j=1 to NumChannels do
	(	--progressupdate(j * 100.0 / NumChannels)
		--if getProgressCancel() then exit()
		if bStop then exit()
	
		local iStep = edtStep.text as integer
		
		if chkDouble.checked == false then
		(	for iStepping = iStep to 100 by iStep do
			(
				progressupdate iStepping
				if getProgressCancel() then 
				(	bStop = true
					exit()
				)
			
				local sChName = asdSetMorphems baseObject selection j iStepping
		
				local sFileName = edtPath.text + sChName + "_" + (iStepping as string)
				if rdo1.state == 1 then sFileName += ".tga"
				else sFileName += ".jpg"
		
				print sFileName
	
				render outputfile:sFileName	vfb:off 
				-- render outputfile:sFileName
	
				asdSetMorphems baseObject selection j 0
			) -- iStepping		
		)
		else
		(	for iStepping = iStep to 50 by iStep do
			(	for i=j to NumChannels do
				(	if i == j then continue
					for iStepping2 = iStep to 50 by iStep do
					(	progressupdate iStepping2
						if getProgressCancel() then
						(	bStop = true
							exit()
						)
			
						local sChName1 = asdSetMorphems baseObject selection j iStepping
						local sChName2 = asdSetMorphems baseObject selection i iStepping2
						completeRedraw()
			
						local sFileName = edtPath.text + sChName1 + "_" + (iStepping as string) + "+" + sChName2 + "_" + (iStepping2 as string)
						if rdo1.state == 1 then sFileName += ".tga"
						else sFileName += ".jpg"
		
						print sFileName
		
						render outputfile:sFileName	vfb:off 
						-- render outputfile:sFileName
	
						asdSetMorphems baseObject selection j 0
						asdSetMorphems baseObject selection i 0
					)-- iStepping2
					if bStop then exit()
				)-- i
				if bStop then exit()
			) -- iStepping		
		)
		
	
	--		local channel = objMorth[j]
	--		channel.value = 0
		
		for i = 1 to countObj do
		(	--if selection[i] != baseObject then 
			(	local object = selection[i]
				local objMorthLocal = object.modifiers[#Morpher]
				if(objMorthLocal != undefined) then
				(	for jLocal=1 to 100 do
					(	local channelLocal = objMorthLocal[jLocal]
						if channelLocal.value != undefined then channelLocal.value = 0
					)
				)
			)
		)
	
	)
	progressend()
	)
	
	---------------------------------------------------------	
	
	)
)

createDialog renderRollout style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

)



sDir = scriptsPath
sDir += "HuntUtilities.txt"

mnu = menuMan.findMenu "&MAXScript"

if mnu != undefined then
(	
	local menuFile = menuMan.getMenuFile() 

	local iSel = 1
	for i = 1 to mnu.numItems() do
	(	local subMenu = mnu.getItem i
		local hasHU = findString (subMenu.getTitle()) "HuntUtilities"
		if (hasHU != undefined and hasHU > 0) then 
		(	iSel = i
			exit()
		)
		
		local hasHU = findString (subMenu.getTitle()) "HU"
		if (hasHU != undefined and hasHU > 0) then 
		(	iSel = i
			exit()
		)
	)
	
	if iSel == 1 then
	(	local sep = menuMan.createSeparatorItem()
		iSel = mnu.numItems() + 1
		mnu.addItem sep iSel
		iSel = mnu.numItems() + 1
	)
	else 
	(	for i = mnu.numItems() to iSel by -1 do (mnu.removeItem (mnu.getItem i))
	)
	
	mnu.addItem (menuMan.createActionItem "HuntUtilitiesNaming" "HuntUtilitiesTools") iSel
	iSel = iSel + 1

	mnu.addItem (menuMan.createActionItem "HuntUtilitiesMaterials" "HuntUtilitiesTools") iSel
	iSel = iSel + 1

	mnu.addItem (menuMan.createActionItem "HuntUtilitiesLights" "HuntUtilitiesTools") iSel
	iSel = iSel + 1

	mnu.addItem (menuMan.createActionItem "HuntUtilitiesModeling" "HuntUtilitiesTools") iSel
	iSel = iSel + 1

	mnu.addItem (menuMan.createActionItem "HuntUtilitiesKeysProps" "HuntUtilitiesTools") iSel
	iSel = iSel + 1

	mnu.addItem (menuMan.createActionItem "HuntUtilitiesRender" "HuntUtilitiesTools") iSel
	iSel = iSel + 1

	mnu.addItem (menuMan.createActionItem "HuntUtilitiesAutoKey" "HuntUtilitiesTools") iSel
	iSel = iSel + 1

	--mnu.addItem (menuMan.createSeparatorItem()) iSel
	--iSel = iSel + 1
	
	mnu.addItem (menuMan.createActionItem "HuntUtilities" "HuntUtilitiesTools") iSel
	iSel = iSel + 1
	
	menuMan.updateMenuBar()
	menuMan.saveMenuFile menuFile

)

sDir = scriptsPath + "HuntUtilities.txt"
deleteFile sDir
bOk1 = copyFile (HuntUtilitiesDir + "HuntUtilities.txt") sDir

-- print ("sx" + (bOk1 as string))
-- print ("sx" + (bOk2 as string))

if bOk1 == true and bOk2 == true then
	messageBox "New version installed successfully." title:"HuntUtilities"


